SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin commentStamp: 'pt 5/3/2009 13:55' prior: 0!
A PhidgetPlugin is a plugin to enable the use of Phidgets (For more information about Phidgets see www.phidgets.com).

Instance Variables: - none -
!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:21'!
cStringOf: byteArray
	
	self returnTypeC: 'char* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) ] ).
	interpreterProxy failed ifTrue: [ interpreterProxy primitiveFail. ^ nil ].
	^ self cCode: '(char*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
initialiseModule
	"Initialise the module"

	self export: true.
	self cCode: 'phidgetPlugin_Initialise()'.
	^ 1! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:20'!
phidgetIdOf: byteArray
	"Return the PhidgetId of the given Smalltalk bytes object, or nil if oop is not a PhidgetId."

	self returnTypeC: 'PhidgetId* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) and:
		 [ ( interpreterProxy slotSizeOf: byteArray ) = ( self cCode: 'sizeof(PhidgetId)' ) ] ] ).
	interpreterProxy failed ifTrue: [ interpreterProxy primitiveFail. ^ nil ].
	^ self cCode: '(PhidgetId*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Phidget: Accelerometer' stamp: 'sp 6/18/2009 17:12'!
primAccelerometerCreate

	self primitive: 'primAccelerometerCreate' parameters: #().
	^ self cCode: 'phidgetAccel_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Advanced Servo' stamp: 'sp 6/26/2009 05:56'!
primAdvancedServoCreate

	self primitive: 'primAdvancedServoCreate' parameters: #().
	^ self cCode: 'phidgetAdvServo_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 21:58'!
primClose: phidgetIdArray

	| phidgetId |
	self primitive: 'primClose' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Close(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:02'!
primGetAdvancedServoAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetAcceleration(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:02'!
primGetAdvancedServoAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMax(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:03'!
primGetAdvancedServoAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMin(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:03'!
primGetAdvancedServoCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetCurrent(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primGetAdvancedServoVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocity(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primGetAdvancedServoVelocityLimit: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityLimit(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primGetAdvancedServoVelocityMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMax(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primGetAdvancedServoVelocityMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMin(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 8/7/2009 22:06'!
primGetAnalogSensorValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAnalogSensorValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAnalogSensor_GetValue(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 21:51'!
primGetAttachedDeviceClass: index

	| bResult iClass classId |
	self primitive: 'primGetAttachedDeviceClass' parameters: #(SmallInteger).
	self var: #bResult type: 'int'.
	self var: #iClass type: 'CPhidget_DeviceClass'.
	
	bResult := self cCode: 'phidgetManager_getAttachedDeviceClass(index, &iClass)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	classId := interpreterProxy integerObjectOf: iClass.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ classId! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 21:51'!
primGetAttachedDeviceLabel: index

	| bResult pcLabel iLabelSize labelOop pcLabelInOop |
	self primitive: 'primGetAttachedDeviceLabel' parameters: #(SmallInteger).
	self var: #bResult type: 'int'.
	self var: #pcLabel type: 'const char *'.
	self var: #iLabelSize type: 'int'.
	self var: #pcLabelInOop type: 'char*'.
	
	"get the label"
	bResult := self cCode: 'phidgetManager_getAttachedDeviceLabel(index, &pcLabel, &iLabelSize)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"convert and copy the string"
	labelOop := interpreterProxy 
		instantiateClass: interpreterProxy classByteArray
		indexableSize: iLabelSize.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	pcLabelInOop := self cCode: '(char *) (labelOop + 4)'.
	self cCode: 'memcpy(pcLabelInOop, pcLabel, iLabelSize)'.
	
	^ labelOop! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/11/2009 17:04'!
primGetAttachedDeviceName: index

	| bResult pcName iNameSize nameOop pcNameInOop |
	self primitive: 'primGetAttachedDeviceName' parameters: #(SmallInteger).
	self var: #bResult type: 'int'.
	self var: #pcName type: 'const char *'.
	self var: #iNameSize type: 'int'.
	self var: #pcNameInOop type: 'char*'.
	
	"get the name"
	bResult := self cCode: 'phidgetManager_getAttachedDeviceName(index, &pcName, &iNameSize)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"convert and copy the string"
	nameOop := interpreterProxy 
		instantiateClass: interpreterProxy classByteArray
		indexableSize: iNameSize.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	pcNameInOop := self cCode: '(char *) (nameOop + 4)'.
	self cCode: 'memcpy(pcNameInOop, pcName, iNameSize)'.
	
	^ nameOop! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/12/2009 14:29'!
primGetAttachedDeviceSerialNumber: index

	| bResult iSerialNumber serialNumber |
	self primitive: 'primGetAttachedDeviceSerialNumber' parameters: #(SmallInteger).
	self var: #bResult type: 'int'.
	self var: #iSerialNumber type: 'int'.
	
	bResult := self cCode: 'phidgetManager_getAttachedDeviceSerialNumber(index, &iSerialNumber)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	serialNumber := interpreterProxy integerObjectOf: iSerialNumber.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ serialNumber! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 21:51'!
primGetAttachedDeviceType: index

	| bResult iType typeId |
	self primitive: 'primGetAttachedDeviceType' parameters: #(SmallInteger).
	self var: #bResult type: 'int'.
	self var: #iType type: 'CPhidget_DeviceID'.
	
	bResult := self cCode: 'phidgetManager_getAttachedDeviceType(index, &iType)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	typeId := interpreterProxy integerObjectOf: iType.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ typeId! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'lk 8/7/2009 22:07'!
primGetAxisAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAxis_GetAcceleration(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'lk 8/7/2009 22:07'!
primGetAxisAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAxis_GetAccelerationMax(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'lk 8/7/2009 22:07'!
primGetAxisAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompAxis_GetAccelerationMin(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/12/2009 14:37'!
primGetDeviceClass: phidgetIdArray

	| phidgetId bResult iClass classId |
	self primitive: 'primGetDeviceClass' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #bResult type: 'int'.
	self var: #iClass type: 'CPhidget_DeviceClass'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	bResult := self cCode: 'phidget_getDeviceClass(phidgetId, &iClass)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	classId := interpreterProxy integerObjectOf: iClass.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ classId! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/12/2009 14:27'!
primGetDeviceName: phidgetIdArray

	| phidgetId bResult pcName iNameSize nameOop pcNameInOop |
	self primitive: 'primGetDeviceName' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #bResult type: 'int'.
	self var: #pcName type: 'const char *'.
	self var: #iNameSize type: 'int'.
	self var: #pcNameInOop type: 'char*'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"get the name"
	bResult := self cCode: 'phidget_getDeviceName(phidgetId, &pcName, &iNameSize)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"convert and copy the string"
	nameOop := interpreterProxy 
		instantiateClass: interpreterProxy classByteArray
		indexableSize: iNameSize.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	pcNameInOop := self cCode: '(char *) (nameOop + 4)'.
	self cCode: 'memcpy(pcNameInOop, pcName, iNameSize)'.
	
	^ nameOop! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/12/2009 14:32'!
primGetDeviceType: phidgetIdArray

	| phidgetId bResult iType typeId |
	self primitive: 'primGetDeviceType' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #bResult type: 'int'.
	self var: #iType type: 'CPhidget_DeviceID'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	bResult := self cCode: 'phidget_getDeviceType(phidgetId, &iType)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	typeId := interpreterProxy integerObjectOf: iType.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ typeId! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 8/7/2009 22:08'!
primGetDigitalInputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalInputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalInput_GetValue(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 8/7/2009 22:08'!
primGetDigitalOutputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalOutputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalOutput_GetValue(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'lk 8/7/2009 22:01'!
primGetDoubleChangeTrigger: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedDoubleChangeTrigger' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetComponent_GetIndexedDoubleChangeTrigger(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'lk 8/7/2009 22:02'!
primGetIntegerChangeTrigger: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedIntegerChangeTrigger' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_GetIndexedIntegerChangeTrigger(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/12/2009 14:41'!
primGetLabel: phidgetIdArray

	| phidgetId bResult pcLabel iLabelSize nameOop pcLabelInOop |
	self primitive: 'primGetLabel' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #bResult type: 'int'.
	self var: #pcLabel type: 'const char *'.
	self var: #iLabelSize type: 'int'.
	self var: #pcLabelInOop type: 'char*'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"get the label"
	bResult := self cCode: 'phidget_getLabel(phidgetId, &pcLabel, &iLabelSize)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	"convert and copy the string"
	nameOop := interpreterProxy 
		instantiateClass: interpreterProxy classByteArray
		indexableSize: iLabelSize.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	pcLabelInOop := self cCode: '(char *) (nameOop + 4)'.
	self cCode: 'memcpy(pcLabelInOop, pcLabel, iLabelSize)'.
	
	^ nameOop! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:11'!
primGetLastRFIDTag: phidgetIdArray

	| phidgetId tagArrayOop tagArray |
	self primitive: 'primGetLastRFIDTag' parameters: #(Oop).
	self var: #tagArray type: 'char *'.
	self var: #phidgetId type: 'PhidgetId'.
	
	tagArrayOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: 5.
	tagArray := self cCode: '(char *) (tagArrayOop + 4)'.
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	self cCode: 'phidgetCompRFID_GetLastTag(phidgetId, tagArray)'.
	^ tagArrayOop! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primGetMotorAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompMotor_GetAcceleration(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primGetMotorAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompMotor_GetAccelerationMax(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primGetMotorAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompMotor_GetAccelerationMin(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primGetMotorCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompMotor_GetCurrent(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primGetMotorVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompMotor_GetVelocity(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 21:51'!
primGetNumberOfAttachedDevices

	| count |
	self primitive: 'primGetNumberOfAttachedDevices' parameters: #( ).
	
	count := interpreterProxy integerObjectOf: ( self cCode: 'phidgetManager_getNumberOfAttachedDevices()' ).
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ count! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/12/2009 14:35'!
primGetSerialNumber: phidgetIdArray

	| phidgetId bResult iSerialNumber serialNumber |
	self primitive: 'primGetSerialNumber' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #bResult type: 'int'.
	self var: #iSerialNumber type: 'int'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	bResult := self cCode: 'phidget_getSerialNumber(phidgetId, &iSerialNumber)'.
	(interpreterProxy failed or: [bResult <= 0]) ifTrue: [ ^ interpreterProxy primitiveFail ].
	
	serialNumber := interpreterProxy integerObjectOf: iSerialNumber.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ serialNumber! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primGetServoPosition: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPosition' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompServoMotor_GetPosition(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primGetServoPositionMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompServoMotor_GetPositionMax(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primGetServoPositionMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy floatObjectOf:
		( self cCode: 'phidgetCompServoMotor_GetPositionMin(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'lk 8/7/2009 22:14'!
primGetTextDisplayColumnCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayColumnCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_ColumnCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'lk 8/7/2009 22:14'!
primGetTextDisplayRowCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayRowCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_RowCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:16'!
primGetTextLCDContrast: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextLCDContrast' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_GetContrast(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:11'!
primHasRFIDTag: phidgetIdArray

	| phidgetId |
	self primitive: 'primHasRFIDTag' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompRFID_HasTag(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Phidget: Interface Kit' stamp: 'lk 6/15/2009 17:14'!
primInterfaceKitCreate

	self primitive: 'primInterfaceKitCreate' parameters: #().
	^ self cCode: 'phidgetIfKit_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primIsAdvancedServoSpeedRampingOn: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_IsSpeedRampingOn(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 21:59'!
primIsAttached: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsAttached' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isAttached(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:11'!
primIsRFIDAntennaOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsRFIDAntennaOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompRFID_IsAntennaOn(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primIsServoEngaged: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsServoEngaged' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompServoMotor_IsEngaged(phidgetId, index)' )! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 8/7/2009 22:14'!
primIsSimpleLEDOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsSimpleLEDOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_IsOn(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:16'!
primIsTextLCDBacklightOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDBacklightOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsBacklightOn(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:16'!
primIsTextLCDCursorBlinking: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorBlinking' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorBlinking(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:17'!
primIsTextLCDCursorOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorOn(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 21:59'!
primIsValid: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsValid' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isValid(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 8/7/2009 21:53'!
primLastError

	| errorCode |
	self primitive: 'primLastError' parameters: #( ).
	
	errorCode := interpreterProxy integerObjectOf: ( self cCode: 'phidget_LastError()' ).
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ errorCode! !

!PhidgetPlugin methodsFor: 'Phidget: Motor Control' stamp: 'sp 6/24/2009 11:55'!
primMotorControlCreate

	self primitive: 'primMotorControlCreate' parameters: #().
	^ self cCode: 'phidgetMotCon_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 8/7/2009 22:07'!
primNumAnalogSensors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAnalogSensors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAnalogSensor_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'lk 8/7/2009 22:07'!
primNumAxes: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAxes' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAxis_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 8/7/2009 22:08'!
primNumDigitalInputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalInputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalInput_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 8/7/2009 22:08'!
primNumDigitalOutputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalOutputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalOutput_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primNumMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompMotor_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primNumServoMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumServoMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompServoMotor_GetCount(phidgetId)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:00'!
primOpen: phidgetIdArray withSerial: serial

	| phidgetId |
	self primitive: 'primOpen' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Open(phidgetId, serial)' )! !

!PhidgetPlugin methodsFor: 'Phidget remote' stamp: 'lk 8/7/2009 21:54'!
primOpenRemote: phidgetIdArray serial: serial serverAddress: addressArray port: port password: pwArray

	| phidgetId pwSize addressSize addressString pwString |
	self primitive: 'primOpenRemoteAddress' parameters: #(Oop SmallInteger Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #addressString type: 'char*'.
	self var: #pwString type: 'char*'.
	
	"convet Squeak Strings into C Strings"	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	addressString := self cCoerce: (interpreterProxy arrayValueOf: addressArray) to: 'char*'.
	addressSize := interpreterProxy stSizeOf: addressArray.
	pwString := self cCoerce: (interpreterProxy arrayValueOf: pwArray) to: 'char*'.
	pwSize := interpreterProxy stSizeOf: pwArray.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_OpenRemoteIP(phidgetId, serial, addressString, addressSize, port, pwString, pwSize)' )! !

!PhidgetPlugin methodsFor: 'Phidget remote' stamp: 'lk 8/7/2009 21:55'!
primOpenRemote: phidgetIdArray serial: serial serverID: idArray password: pwArray

	| phidgetId pwSize idSize idString pwString |
	self primitive: 'primOpenRemoteID' parameters: #(Oop SmallInteger Oop Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #idString type: 'char*'.
	self var: #pwString type: 'char*'.
	
	"convet Squeak Strings into C Strings"
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	idString := self cCoerce: (interpreterProxy arrayValueOf: idArray) to: 'char*'.
	idSize := interpreterProxy stSizeOf: idArray.
	pwString := self cCoerce: (interpreterProxy arrayValueOf: pwArray) to: 'char*'.
	pwSize := interpreterProxy stSizeOf: pwArray.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_OpenRemoteID(phidgetId, serial, idString, idSize, pwString, pwSize)' )! !

!PhidgetPlugin methodsFor: 'Phidget: RFID' stamp: 'lk 6/15/2009 21:04'!
primRFIDCreate

	self primitive: 'primRFIDCreate' parameters: #().
	^ self cCode: 'phidgetRFID_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Servo' stamp: 'lk 6/15/2009 22:19'!
primServoCreate

	self primitive: 'primServoCreate' parameters: #().
	^ self cCode: 'phidgetServo_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:05'!
primSetAdvancedServoAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetAdvancedServoAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetAcceleration(phidgetId, index, floatAcceleration)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetAdvancedServoPositionMax: phidgetIdArray at: index to: positionMax

	| phidgetId floatPositionMax |
	self primitive: 'primSetAdvancedServoPositionMax' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMax := interpreterProxy floatValueOf: positionMax.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMax(phidgetId, index, floatPositionMax)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetAdvancedServoPositionMin: phidgetIdArray at: index to: positionMin

	| phidgetId floatPositionMin |
	self primitive: 'primSetAdvancedServoPositionMin' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMin := interpreterProxy floatValueOf: positionMin.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMin(phidgetId, index, floatPositionMin)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetAdvancedServoSpeedRampingOn: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetSpeedRampingOn(phidgetId, index, state)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetAdvancedServoVelocityLimit: phidgetIdArray at: index to: velocityLimit

	| phidgetId floatVelocityLimit |
	self primitive: 'primSetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocityLimit := interpreterProxy floatValueOf: velocityLimit.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetVelocityLimit(phidgetId, index, floatVelocityLimit)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 8/7/2009 22:08'!
primSetDigitalOutputValue: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetDigitalOutputValue' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalOutput_SetValue(phidgetId, index, value)' )! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'lk 8/7/2009 22:02'!
primSetDoubleChangeTrigger: phidgetIdArray at: index to: value

	|floatSensitivity phidgetId|
	self primitive: 'primSetIndexedDoubleChangeTrigger' parameters: #(Oop SmallInteger Oop ).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatSensitivity type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatSensitivity := interpreterProxy floatValueOf: value.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_SetIndexedDoubleChangeTrigger(phidgetId, index, floatSensitivity)' )! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'lk 8/7/2009 22:02'!
primSetIntegerChangeTrigger: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetIndexedIntegerChangeTrigger' parameters: #(Oop SmallInteger SmallInteger ).
	self var: #phidgetId type: 'PhidgetId'.

	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_SetIndexedIntegerChangeTrigger(phidgetId, index, value)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:09'!
primSetMotorAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetMotorAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompMotor_SetAcceleration(phidgetId, index, floatAcceleration)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:10'!
primSetMotorVelocity: phidgetIdArray at: index to: velocity

	| phidgetId floatVelocity |
	self primitive: 'primSetMotorVelocity' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocity := interpreterProxy floatValueOf: velocity.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompMotor_SetVelocity(phidgetId, index, floatVelocity)' )! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 22:01'!
primSetPMSemaphoreIndexAttach: semaIndex

	| ret |
	self primitive: 'primSetPMSemaphoreIndexAttach' parameters: #(SmallInteger).
	
	ret := interpreterProxy integerObjectOf:
		( self cCode: 'phidgetManager_SetSemaphoreIndex_Attach(semaIndex)' ).
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ ret! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 22:01'!
primSetPMSemaphoreIndexDetach: semaIndex

	| ret |
	self primitive: 'primSetPMSemaphoreIndexDetach' parameters: #(SmallInteger).
	
	ret := interpreterProxy integerObjectOf:
		( self cCode: 'phidgetManager_SetSemaphoreIndex_Detach(semaIndex)' ).
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ ret! !

!PhidgetPlugin methodsFor: 'PhidgetManager' stamp: 'lk 8/7/2009 22:01'!
primSetPMSemaphoreIndexError: semaIndex

	| ret |
	self primitive: 'primSetPMSemaphoreIndexError' parameters: #(SmallInteger).
	
	ret := interpreterProxy integerObjectOf:
		( self cCode: 'phidgetManager_SetSemaphoreIndex_Error(semaIndex)' ).
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ ret! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:11'!
primSetRFIDAntennaState: phidgetIdArray to: anInteger

	| phidgetId |
	self primitive: 'primSetRFIDAntennaState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompRFID_SetAntennaState(phidgetId, anInteger)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetSemaphoreIndexAdvancedServoCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'lk 8/7/2009 22:06'!
primSetSemaphoreIndexAdvancedServoVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 8/7/2009 22:07'!
primSetSemaphoreIndexAnalogSensorChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAnalogSensorChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAnalogSensor_SetSemaphoreIndex_ValueChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:00'!
primSetSemaphoreIndexAttach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAttach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_SetSemaphoreIndex_Attach(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'lk 8/7/2009 22:07'!
primSetSemaphoreIndexAxisChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAxisChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompAxis_SetSemaphoreIndex_AccelerationChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:00'!
primSetSemaphoreIndexDetach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDetach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_SetSemaphoreIndex_Detach(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 8/7/2009 22:08'!
primSetSemaphoreIndexDigitalInputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalInputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalInput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 8/7/2009 22:08'!
primSetSemaphoreIndexDigitalOutputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalOutputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompDigitalOutput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 8/7/2009 22:00'!
primSetSemaphoreIndexError: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexError' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_SetSemaphoreIndex_Error(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:10'!
primSetSemaphoreIndexMotorCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'lk 8/7/2009 22:10'!
primSetSemaphoreIndexMotorVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:11'!
primSetSemaphoreIndexRFIDTagFound: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagFound' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagFound(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 8/7/2009 22:12'!
primSetSemaphoreIndexRFIDTagLost: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagLost' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagLost(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:12'!
primSetSemaphoreIndexServoPositionChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexServoPositionChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompServoMotor_SetSemaphoreIndex_PositionChange(phidgetId, semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:13'!
primSetServoEngaged: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetServoEngaged' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompServoMotor_SetEngaged(phidgetId, index, state)' )! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 8/7/2009 22:13'!
primSetServoPosition: phidgetIdArray at: index to: position

	| phidgetId floatPosition |
	self primitive: 'primSetServoPosition' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPosition := interpreterProxy floatValueOf: position.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompServoMotor_SetPosition(phidgetId, index, floatPosition)' )! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 8/7/2009 22:14'!
primSetSimpleLEDState: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetSimpleLEDState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_SetState(phidgetId, state)' )! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'lk 8/7/2009 22:16'!
primSetTextDisplayCharacter: phidgetIdArray in: row and: column to: charStringArray

	| phidgetId character |
	self primitive: 'primSetTextDisplayCharacter' parameters: #(Oop SmallInteger SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #character type: 'char'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	(interpreterProxy stSizeOf: charStringArray) ~= 1 ifTrue: [ ^ interpreterProxy primitiveFail ].
	character := ( self
		cCoerce: (interpreterProxy arrayValueOf: charStringArray)
		to: 'char*' ) at: 0.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompTextLCD_DisplayCharacter(phidgetId, row, column, character)' )! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'lk 8/7/2009 22:16'!
primSetTextDisplayString: phidgetIdArray in: row to: stringArray

	| phidgetId string size |
	self primitive: 'primSetTextDisplayString' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #string type: 'char*'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	string := self cCoerce: (interpreterProxy arrayValueOf: stringArray) to: 'char*'.
	size := interpreterProxy stSizeOf: stringArray.
	
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidgetCompTextLCD_DisplayString(phidgetId, row, string, size)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:17'!
primSetTextLCDBacklightOn: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDBacklightOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetBacklightOn(phidgetId, state)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:17'!
primSetTextLCDContrast: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDContrast' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetContrast(phidgetId, state)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:17'!
primSetTextLCDCursorBlinking: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDCursorBlinking' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetCursorBlinking(phidgetId, state)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'lk 8/7/2009 22:17'!
primSetTextLCDCursorOn: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDCursorOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetCursorOn(phidgetId, state)' )! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 8/12/2009 19:33'!
primSetTextLCDCustomChar: phidgetIdArray at: index to: upper and: lower

	| phidgetId |
	self primitive: 'primSetTextLCDCustomChar' parameters: #(Oop SmallInteger SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifTrue: [ ^ interpreterProxy primitiveFail ].
	^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetCustomChar(phidgetId, index, upper, lower)' )! !

!PhidgetPlugin methodsFor: 'Phidget: TextLCD' stamp: 'fs 7/5/2009 18:40'!
primTextLCDCreate

	self primitive: 'primTextLCDCreate' parameters: #().
	^ self cCode: 'phidgetTextLCD_Create()'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	self cCode: 'phidgetPlugin_Shutdown()'.
	^ 1! !
